﻿# Run Powershell as administrator (Script grants backup privilege - read all files regardless of ACL)
# AlphaFS Privilege --> http://alphafs.alphaleonis.com/doc/2.0/api/html/AC5B7CEB.htm

# Spremeni pot in lokacijo dll, (trenutno) potrebujemo WINDOWS Powershell !
Import-Module -name "C:\Users\Halis\Desktop\2.2.6\AlphaFS.dll"

# Kje iscemo datoteke
$Pot = "C:\windows\"

$stringBuilder = New-Object System.Text.StringBuilder
$null = $stringBuilder.Append("Length`tType`tMapa`tFull Name`r`n")

$privilegeEnabler = $Null

$Server = $env:COMPUTERNAME
$FolderChar = $Pot.Split("\").Count
$OutputFile = "$env:USERPROFILE\Desktop\LongName-$Server.csv"
$OutputReport = "$env:USERPROFILE\Desktop\LongName-$Server.txt"

[int]$znaki = 20

Try {
    $privilege = [Alphaleonis.Win32.Security.Privilege]::Backup
    $privilegeEnabler = New-Object Alphaleonis.Win32.Security.PrivilegeEnabler($privilege)

    [array]$files = [Alphaleonis.Win32.Filesystem.Directory]::EnumerateFileSystemEntries("$Pot", "*", [System.IO.SearchOption]::AllDirectories)
    $vsi = $files.Count

    foreach ($file in $files) {          
        if ($file.Length -gt $znaki) {
            if ( $File.IndexOf(".") -gt $File.IndexOf("`\") ) {
                $folderName = $file.Split("\")[$FolderChar]
                $null = $stringBuilder.Append("$($file.Length)`tFile`t$folderName`t$file`r`n")
            }
            else { $null = $stringBuilder.Append("$($file.Length)`tFolder`t$folderName`t$file`r`n") }
        } # End If
    } # End foreach

    $stringBuilder.ToString() | Out-File $OutputFile
} # End Try

Catch { $_ }

Finally { 
    If ($Null -ne $privilegeEnabler) { $privilegeEnabler.Dispose() }
}

$CSVImported = Import-Csv $OutputFile -Delimiter "`t" -Encoding Unicode
#$CSVImported | Sort "Length" | ogv
$FileCount = ($CSVImported | ? { $_.Type -eq "File" }).Count
$FolderCount = $CSVImported.Count - $FileCount

$Content = @" 
$Server
******************************************
Vse skupaj datoteke in mape: `t$vsi

Vse skupaj tezavne mape: `t$FolderCount
Vse skupaj tezavne datoteke: `t$FileCount
`t`t`t`t-----
Vse skupaj tezavna pot: `t$($CSVImported.Count)
"@

Set-Content $OutputReport $Content

"$Server"
"******************************************"
"Vse skupaj datoteke in mape: `t$vsi"
""
"Vse skupaj tezavne mape: `t`t$FolderCount"
"Vse skupaj tezavne datoteke: `t$FileCount"
"`t`t`t`t`t`t`t`t-----"
"Vse skupaj tezavna pot: `t`t$($CSVImported.Count)"